"use strict";module.exports=parse,parse.filename=null,parse.defaults={keepCase:!1};var tokenize=require("./tokenize"),Root=require("./root"),Type=require("./type"),Field=require("./field"),MapField=require("./mapfield"),OneOf=require("./oneof"),Enum=require("./enum"),Service=require("./service"),Method=require("./method"),types=require("./types"),util=require("./util"),base10Re=/^[1-9][0-9]*$/,base10NegRe=/^-?[1-9][0-9]*$/,base16Re=/^0[x][0-9a-fA-F]+$/,base16NegRe=/^-?0[x][0-9a-fA-F]+$/,base8Re=/^0[0-7]+$/,base8NegRe=/^-?0[0-7]+$/,numberRe=/^(?![eE])[0-9]*(?:\.[0-9]*)?(?:[eE][+-]?[0-9]+)?$/,nameRe=/^[a-zA-Z_][a-zA-Z_0-9]*$/,typeRefRe=/^(?:\.?[a-zA-Z_][a-zA-Z_0-9]*)(?:\.[a-zA-Z_][a-zA-Z_0-9]*)*$/,fqTypeRefRe=/^(?:\.[a-zA-Z_][a-zA-Z_0-9]*)+$/;function parse(e,t,r){t instanceof Root||(r=t,t=new Root),r||(r=parse.defaults);var n,a,o,i,s,f=r.preferTrailingComment||!1,c=tokenize(e,r.alternateCommentMode||!1),p=c.next,u=c.push,l=c.peek,d=c.skip,h=c.cmnt,m=!0,w=!1,v=t,R=r.keepCase?function(e){return e}:util.camelCase;function b(e,t,r){var n=parse.filename;return r||(parse.filename=null),Error("illegal "+(t||"token")+" '"+e+"' ("+(n?n+", ":"")+"line "+c.line+")")}function k(){var e,t=[];do{if('"'!==(e=p())&&"'"!==e)throw b(e);t.push(p()),d(e),e=l()}while('"'===e||"'"===e);return t.join("")}function y(e){var t=p();switch(t){case"'":case'"':return u(t),k();case"true":case"TRUE":return!0;case"false":case"FALSE":return!1}try{var r=t,n=!0,a=1;switch("-"===r.charAt(0)&&(a=-1,r=r.substring(1)),r){case"inf":case"INF":case"Inf":return 1/0*a;case"nan":case"NAN":case"Nan":case"NaN":return NaN;case"0":return 0}if(base10Re.test(r))return a*parseInt(r,10);if(base16Re.test(r))return a*parseInt(r,16);if(base8Re.test(r))return a*parseInt(r,8);if(numberRe.test(r))return a*parseFloat(r);throw b(r,"number",n)}catch(r){if(e&&typeRefRe.test(t))return t;throw b(t,"value")}}function g(e,t){do t&&('"'===(r=l())||"'"===r)?e.push(k()):e.push([n=q(p()),d("to",!0)?q(p()):n]);while(d(",",!0));var r,n,a={options:void 0};a.setOption=function(e,t){void 0===this.options&&(this.options={}),this.options[e]=t},x(a,function(e){if("option"===e)F(a,e),d(";");else throw b(e)},function(){$(a)})}function q(e,t){switch(e){case"max":case"MAX":case"Max":return 0x1fffffff;case"0":return 0}if(!t&&"-"===e.charAt(0))throw b(e,"id");if(base10NegRe.test(e))return parseInt(e,10);if(base16NegRe.test(e))return parseInt(e,16);if(base8NegRe.test(e))return parseInt(e,8);throw b(e,"id")}function A(e,t){switch(t){case"option":return F(e,t),d(";"),!0;case"message":return N(e,t),!0;case"enum":return _(e,t),!0;case"service":return function(e,t){if(!nameRe.test(t=p()))throw b(t,"service name");var r=new Service(t);x(r,function(e){if(!A(r,e))if("rpc"===e)!function(e,t){var r=h(),n=t;if(!nameRe.test(t=p()))throw b(t,"name");var a,o,i,s,f=t;if(d("("),d("stream",!0)&&(o=!0),!typeRefRe.test(t=p())||(a=t,d(")"),d("returns"),d("("),d("stream",!0)&&(s=!0),!typeRefRe.test(t=p())))throw b(t);i=t,d(")");var c=new Method(f,n,a,i,o,s);c.comment=r,x(c,function(e){if("option"===e)F(c,e),d(";");else throw b(e)}),e.add(c)}(r,e);else throw b(e)}),e.add(r)}(e,t),!0;case"extend":return function(e,t){if(!typeRefRe.test(t=p()))throw b(t,"reference");var r=t;x(null,function(t){switch(t){case"required":case"repeated":O(e,t,r);break;case"optional":w?O(e,"proto3_optional",r):O(e,"optional",r);break;default:if(!w||!typeRefRe.test(t))throw b(t);u(t),O(e,"optional",r)}})}(e,t),!0}return!1}function x(e,t,r){var n,a=c.line;if(e&&("string"!=typeof e.comment&&(e.comment=h()),e.filename=parse.filename),d("{",!0)){for(;"}"!==(n=p());)t(n);d(";",!0)}else r&&r(),d(";"),e&&("string"!=typeof e.comment||f)&&(e.comment=h(a)||e.comment)}function N(e,t){if(!nameRe.test(t=p()))throw b(t,"type name");var r=new Type(t);x(r,function(e){if(!A(r,e))switch(e){case"map":var t=r;d("<");var n=p();if(void 0===types.mapKey[n])throw b(n,"type");d(",");var a=p();if(!typeRefRe.test(a))throw b(a,"type");d(">");var o=p();if(!nameRe.test(o))throw b(o,"name");d("=");var i=new MapField(R(o),q(p()),n,a);x(i,function(e){if("option"===e)F(i,e),d(";");else throw b(e)},function(){$(i)}),t.add(i);break;case"required":case"repeated":O(r,e);break;case"optional":w?O(r,"proto3_optional"):O(r,"optional");break;case"oneof":var s=r,f=e;if(!nameRe.test(f=p()))throw b(f,"name");var c=new OneOf(R(f));x(c,function(e){"option"===e?(F(c,e),d(";")):(u(e),O(c,"optional"))}),s.add(c);break;case"extensions":g(r.extensions||(r.extensions=[]));break;case"reserved":g(r.reserved||(r.reserved=[]),!0);break;default:if(!w||!typeRefRe.test(e))throw b(e);u(e),O(r,"optional")}}),e.add(r)}function O(e,t,r){var n=p();if("group"===n)return void function(e,t){var r=p();if(!nameRe.test(r))throw b(r,"name");var n=util.lcFirst(r);r===n&&(r=util.ucFirst(r)),d("=");var a=q(p()),o=new Type(r);o.group=!0;var i=new Field(n,a,r,t);i.filename=parse.filename,x(o,function(e){switch(e){case"option":F(o,e),d(";");break;case"required":case"repeated":O(o,e);break;case"optional":w?O(o,"proto3_optional"):O(o,"optional");break;case"message":N(o,e);break;case"enum":_(o,e);break;default:throw b(e)}}),e.add(o).add(i)}(e,t);for(;n.endsWith(".")||l().startsWith(".");)n+=p();if(!typeRefRe.test(n))throw b(n,"type");var a=p();if(!nameRe.test(a))throw b(a,"name");a=R(a),d("=");var o=new Field(a,q(p()),n,t,r);if(x(o,function(e){if("option"===e)F(o,e),d(";");else throw b(e)},function(){$(o)}),"proto3_optional"===t){var i=new OneOf("_"+a);o.setOption("proto3_optional",!0),i.add(o),e.add(i)}else e.add(o);!w&&o.repeated&&(void 0!==types.packed[n]||void 0===types.basic[n])&&o.setOption("packed",!1,!0)}function _(e,t){if(!nameRe.test(t=p()))throw b(t,"name");var r=new Enum(t);x(r,function(e){switch(e){case"option":F(r,e),d(";");break;case"reserved":g(r.reserved||(r.reserved=[]),!0);break;default:var t=r,n=e;if(!nameRe.test(n))throw b(n,"name");d("=");var a=q(p(),!0),o={options:void 0};o.setOption=function(e,t){void 0===this.options&&(this.options={}),this.options[e]=t},x(o,function(e){if("option"===e)F(o,e),d(";");else throw b(e)},function(){$(o)}),t.add(n,a,o.comment,o.options)}}),e.add(r)}function F(e,t){var r,a,o,i,s,f=d("(",!0);if(!typeRefRe.test(t=p()))throw b(t,"name");var c=t,u=c;f&&(d(")"),u=c="("+c+")",t=l(),fqTypeRefRe.test(t)&&(s=t.slice(1),c+=t,p())),d("=");var h=function e(t,r){if(d("{",!0)){for(var a={};!d("}",!0);){if(!nameRe.test(n=p()))throw b(n,"name");if(null===n)throw b(n,"end of input");var o,i,s=n;if(d(":",!0),"{"===l())o=e(t,r+"."+n);else if("["===l()){if(o=[],d("[",!0)){do i=y(!0),o.push(i);while(d(",",!0));d("]"),void 0!==i&&z(t,r+"."+n,i)}}else o=y(!0),z(t,r+"."+n,o);var f=a[s];f&&(o=[].concat(f).concat(o)),a[s]=o,d(",",!0),d(";",!0)}return a}var c=y(!0);return z(t,r,c),c}(e,c);r=e,a=u,o=h,i=s,r.setParsedOption&&r.setParsedOption(a,o,i)}function z(e,t,r){e.setOption&&e.setOption(t,r)}function $(e){if(d("[",!0)){do F(e,"option");while(d(",",!0));d("]")}return e}for(;null!==(n=p());)switch(n){case"package":if(!m)throw b(n);if(void 0!==a)throw b("package");if(a=p(),!typeRefRe.test(a))throw b(a,"name");v=v.define(a),d(";");break;case"import":if(!m)throw b(n);!function(){var e,t=l();switch(t){case"weak":e=i||(i=[]),p();break;case"public":p();default:e=o||(o=[])}t=k(),d(";"),e.push(t)}();break;case"syntax":if(!m)throw b(n);if(d("="),!(w="proto3"===(s=k()))&&"proto2"!==s)throw b(s,"syntax");d(";");break;case"option":F(v,n),d(";");break;default:if(A(v,n)){m=!1;continue}throw b(n)}return parse.filename=null,{package:a,imports:o,weakImports:i,syntax:s,root:t}}